Index: gutenbach-queue/lib/build-gutenbach-queue
===================================================================
--- gutenbach-queue/lib/build-gutenbach-queue	(revision e87e682008b20061e88abcb383650485c76c3f88)
+++ gutenbach-queue/lib/build-gutenbach-queue	(revision e87e682008b20061e88abcb383650485c76c3f88)
@@ -0,0 +1,15 @@
+#!/bin/bash
+
+if [ -e /var/run/gutenbach/current_queue_temp ]; then
+    rm /var/run/gutenbach/current_queue_temp
+fi
+
+while true; do
+    time=$(date)
+    echo "This is a work in progress!  Please send bugs to jhamrick." >> /var/run/gutenbach/current_queue_temp
+    echo ""
+    echo "As of $time:" >> /var/run/gutenbach/current_queue_temp
+    /usr/lib/gutenbach/queue/queue >> /var/run/gutenbach/current_queue_temp
+    mv /var/run/gutenbach/current_queue_temp /var/run/gutenbach/current_queue
+    chmod ugoa+r /var/run/gutenbach/current_queue
+done
Index: gutenbach-queue/lib/kill-gutenbach-queue
===================================================================
--- gutenbach-queue/lib/kill-gutenbach-queue	(revision e87e682008b20061e88abcb383650485c76c3f88)
+++ gutenbach-queue/lib/kill-gutenbach-queue	(revision e87e682008b20061e88abcb383650485c76c3f88)
@@ -0,0 +1,13 @@
+#!/bin/bash
+
+echo "Stopping view-gutenbach-queue..."
+killall -q "/usr/lib/gutenbach/queue/view-gutenbach-queue"
+echo "Stopping build-gutenbach-queue..."
+killall -q "/usr/lib/gutenbach/queue/build-gutenbach-queue"
+echo "Stopping queue..."
+killall -q "/usr/lib/gutenbach/queue/queue"
+echo "Stopping exiftool..."
+killall -q "/usr/bin/exiftool"
+echo "Stopping watch..."
+killall -q "/usr/bin/watch"
+echo "Done."
Index: gutenbach-queue/lib/queue
===================================================================
--- gutenbach-queue/lib/queue	(revision e87e682008b20061e88abcb383650485c76c3f88)
+++ gutenbach-queue/lib/queue	(revision e87e682008b20061e88abcb383650485c76c3f88)
@@ -0,0 +1,59 @@
+#!/bin/bash
+
+found_current=
+
+if [ -e "/var/run/gutenbach/queue_times" ]; then
+    rm "/var/run/gutenbach/queue_times"
+fi
+
+if [ -e /usr/lib/gutenbach/config/printername ]; then
+    printername=$(cat /usr/lib/gutenbach/config/printername)
+
+    cd /var/spool/lpd/"$printername"/
+    for i in $(ls . | grep ^hf); do
+	done=$(cat "$i" | grep done)
+    if [ ! -n "$done" ]; then
+	timestamp=$(cat "$i" | grep ^job_time= | sed 's/.*=//')
+	echo "$timestamp:$i" >> /var/run/gutenbach/queue_times
+    fi
+    done
+
+    if [ -e /var/run/gutenbach/queue_times ]; then
+	for i in $(sort /var/run/gutenbach/queue_times); do
+	    i=$(echo "$i" | sed 's/.*://')
+	    prefix="df"${i:2}
+	    for j in "$prefix"*; do song="$j"; done
+
+	    user=$(cat "$i" | grep ^P=)
+	    user=${user:2}
+	    
+	    if [ -e /var/run/gutenbach/exiftool_data ]; then
+		rm /var/run/gutenbach/exiftool_data
+	    fi
+
+	    exiftool "$song" >> /var/run/gutenbach/exiftool_data
+	    title=$(cat /var/run/gutenbach/exiftool_data | grep "^Title " | sed 's/.*: //')
+	    artist=$(cat /var/run/gutenbach/exiftool_data | grep "^Artist " | sed 's/.*: //')
+
+	    if [ -z "$found_current" ]; then
+		host=$(cat "$i" | grep ^H=)
+		host=${host:2}
+		filenm="$(cat $i | grep "^filenames" | sed -e 's/filenames=//')"
+		album=$(cat /var/run/gutenbach/exiftool_data | grep "^Album " | sed 's/.*: //')
+		echo "$user@$host is currently playing: "
+		echo "$filenm"
+		echo "'$title'"
+		echo "by '$artist'"
+		echo "on '$album'"
+		echo ""
+		echo "Coming up in the queue:"
+		found_current="true" 
+	    else
+		echo "$user: '$title' by '$artist'"
+	    fi
+	done
+    fi
+else
+    echo "Error: Printer name configuration file /usr/lib/gutenbach/config/printername does not exist!"
+    exit 1
+fi
Index: gutenbach-queue/lib/view-gutenbach-queue
===================================================================
--- gutenbach-queue/lib/view-gutenbach-queue	(revision e87e682008b20061e88abcb383650485c76c3f88)
+++ gutenbach-queue/lib/view-gutenbach-queue	(revision e87e682008b20061e88abcb383650485c76c3f88)
@@ -0,0 +1,9 @@
+#!/bin/bash
+
+daemon --running --name gutenbach-queue -F /var/run/gutenbach/gutenbach-queue.pid
+if [ "$?" == 0 ]; then
+    setterm -blank 0
+    watch -t -n 1 cat /var/run/gutenbach/current_queue
+else
+    echo "The gutenbach queue daemon is not running.  Please start it at /etc/init.d/gutenbach-queue."
+fi
